Package: org.codehaus.groovy.classgen.asm

## [Java] Class BinaryExpressionWriter

- org.codehaus.groovy.classgen.asm.BinaryExpressionWriter

- Authors:
    Jochen "blackdrag" Theodorou

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static int[]` | `stdCompareCodes` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `BinaryExpressionWriter (WriterController controller)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `boolean` | `arrayGet(int operation, boolean simulate)`
    `` | `boolean` | `arraySet(boolean simulate)`
    `` | `protected void` | `doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected MethodCaller` | `getArrayGetCaller()`
    `` | `protected ClassNode` | `getArrayGetResultType()`
    `` | `protected MethodCaller` | `getArraySetCaller()`
    `` | `protected int` | `getBitwiseOperationBytecode(int type)`
    `` | `protected int` | `getCompareCode()`
    `` | `protected ClassNode` | `getDevisionOpResultType()`
    `` | `protected ClassNode` | `getNormalOpResultType()`
    `` | `protected int` | `getShiftOperationBytecode(int type)`
    `` | `protected int` | `getStandardOperationBytecode(int type)`
    `` | `protected void` | `removeTwoOperands(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected boolean` | `supportsDivision()`
    `` | `boolean` | `write(int operation, boolean simulate)`
    `` | `protected boolean` | `writeBitwiseOp(int type, boolean simulate)` writes some the bitwise operations. type is one of BITWISE_OR, BITWISE_AND, BIWISE_XOR
    `` | `protected boolean` | `writeDivision(boolean simulate)`
    `` | `protected void` | `writeMinusMinus(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected void` | `writePlusPlus(org.objectweb.asm.MethodVisitor mv)`
    `` | `boolean` | `writePostOrPrefixMethod(int operation, boolean simulate)`
    `` | `protected boolean` | `writeShiftOp(int type, boolean simulate)` Write shifting operations.
    `` | `protected boolean` | `writeSpaceship(int type, boolean simulate)`
    `` | `protected boolean` | `writeStdCompare(int type, boolean simulate)` writes some int standard operations. type is one of IADD, ISUB, IMUL, IDIV or IREM
    `` | `protected boolean` | `writeStdOperators(int type, boolean simulate)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected static final int[] stdCompareCodes

  - ### Constructor Detail

    - #### public BinaryExpressionWriter(WriterController controller)

  - ### Method Detail

    - #### public boolean arrayGet(int operation, boolean simulate)

    - #### public boolean arraySet(boolean simulate)

    - #### protected void doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)

    - #### protected MethodCaller getArrayGetCaller()

    - #### protected ClassNode getArrayGetResultType()

    - #### protected MethodCaller getArraySetCaller()

    - #### protected int getBitwiseOperationBytecode(int type)

    - #### protected int getCompareCode()

    - #### protected ClassNode getDevisionOpResultType()

    - #### protected ClassNode getNormalOpResultType()

    - #### protected int getShiftOperationBytecode(int type)

    - #### protected int getStandardOperationBytecode(int type)

    - #### protected void removeTwoOperands(org.objectweb.asm.MethodVisitor mv)

    - #### protected boolean supportsDivision()

    - #### public boolean write(int operation, boolean simulate)

    - #### protected boolean writeBitwiseOp(int type, boolean simulate)

      writes some the bitwise operations. type is one of BITWISE_OR, BITWISE_AND, BIWISE_XOR

      Parameters:
        `type` - the token type
      Returns:
        true if a successful bitwise operation write

    - #### protected boolean writeDivision(boolean simulate)

    - #### protected void writeMinusMinus(org.objectweb.asm.MethodVisitor mv)

    - #### protected void writePlusPlus(org.objectweb.asm.MethodVisitor mv)

    - #### public boolean writePostOrPrefixMethod(int operation, boolean simulate)

    - #### protected boolean writeShiftOp(int type, boolean simulate)

      Write shifting operations. Type is one of LEFT_SHIFT, RIGHT_SHIFT, or RIGHT_SHIFT_UNSIGNED

      Parameters:
        `type` - the token type
      Returns:
        true on a successful shift operation write

    - #### protected boolean writeSpaceship(int type, boolean simulate)

    - #### protected boolean writeStdCompare(int type, boolean simulate)

      writes some int standard operations. type is one of IADD, ISUB, IMUL, IDIV or IREM

      Parameters:
        `type` - the token type
      Returns:
        true if a successful std operator write

    - #### protected boolean writeStdOperators(int type, boolean simulate)